/*============================================================================*/
/*     Header file for command dictionary routines                            */
/*============================================================================*/
#define CMDDICT_H

#ifdef CMDDICT_C
void seq_init(void);
void seq_initII(void);
void seq_init_update(void);
void ccdexp_start(void);
void ccdexp_terminate(void);
void ccdexp_abort(void);
void clear_ccd(void);
int ccd_expose(void);
int ccd_read(void);
void echo(void);
void set_exptimer(void);
void set_cyctime(void);
void tx_extend(void);
void set_impath(void);
void set_fprefix(void);
void set_nfsave(void);
void set_loop_num(void);
void set_cycle(void);
void set_autotemp(void);
void set_autowipe(void);
void set_autoflush(void);
void set_autosave(void);
void set_rdflag(void);
void set_autoshutter(void);
void hh_set_nrows(void);
void hh_set_ncols(void);
void hh_set_hbin(void);
void hh_set_vbin(void);
void hh_set_namps(void);
void hh_set_nccd(void);
void hh_set_nch(void);
void hh_set_gain(void);
void hh_set_usec(void);
void hh_set_opch(void);
void hh_set_sclks(void);
void hh_set_pid(void);
void hh_exp_status(void);
void hh_set_vdacs(void);
void hh_get_vdacs(void);
void hh_set_ccdtemp(void);
void hh_get_ccdtemp(void);
void hh_set_heat(void);
void hh_get_heat(void);
//void hh_set_hsub(void);
//void hh_set_vsub(void);
//void hh_set_hskip(void);
//void hh_set_vskip(void);
//void hh_set_wm(void);
//void hh_set_nreads(void);
void show_image(void);
void save_fitsimage(void);
void cx_scriptrun(void);
void get_cmdline(void);
void set_ddconfig(void);
void set_xrange(void);
void set_yrange(void);
void set_zrange(void);
void set_zmin(void);
void set_zmax(void);
void set_zspan(void);
void plot_col(void);
void plot_row(void);
void plot_coladd(void);
void plot_rowadd(void);
//void set_wmseq(void);
//void set_displaymode(void);
#endif

#ifndef CMDDICT_C
extern void seq_init(void);
extern void seq_initII(void);
extern void seq_init_update(void);
extern void ccdexp_start(void);
extern void ccdexp_terminate(void);
extern void ccdexp_abort(void);
extern void clear_ccd(void);
extern int ccd_expose(void);
extern int ccd_read(void);
extern void echo(void);
extern void set_exptimer(void);
extern void set_cyctime(void);
extern void tx_extend(void);
extern void set_impath(void);
extern void set_fprefix(void);
extern void set_nfsave(void);
extern void set_loop_num(void);
extern void set_cycle(void);
extern void set_autotemp(void);
extern void set_autowipe(void);
extern void set_autoflush(void);
extern void set_autosave(void);
extern void set_rdflag(void);
extern void set_autoshutter(void);
extern void hh_set_nrows(void);
extern void hh_set_ncols(void);
extern void hh_set_hbin(void);
extern void hh_set_vbin(void);
extern void hh_set_namps(void);
extern void hh_set_nccd(void);
extern void hh_set_nch(void);
extern void hh_set_gain(void);
extern void hh_set_usec(void);
extern void hh_set_opch(void);
extern void hh_set_sclks(void);
extern void hh_set_pid(void);
extern void hh_exp_status(void);
extern void hh_set_vdacs(void);
extern void hh_get_vdacs(void);
extern void hh_set_ccdtemp(void);
extern void hh_get_ccdtemp(void);
extern void hh_set_heat(void);
extern void hh_get_heat(void);
//extern void hh_set_hsub(void);
//extern void hh_set_vsub(void);
//extern void hh_set_hskip(void);
//extern void hh_set_vskip(void);
//extern void hh_set_wm(void);
//extern void hh_set_nreads(void);
extern void show_image(void);
extern void save_fitsimage(void);
extern void get_cmdline(void);
extern void cx_scriptrun(void);
extern void set_ddconfig(void);
extern void set_xrange(void);
extern void set_yrange(void);
extern void set_zrange(void);
extern void set_zmin(void);
extern void set_zmax(void);
extern void set_zspan(void);
extern void plot_col(void);
extern void plot_row(void);
extern void plot_coladd(void);
extern void plot_rowadd(void);
//extern void set_wmseq(void);
//extern void set_displaymode(void);
#endif
