/*============================================================================*/
/*     Window related functions for motxer                                    */
/*============================================================================*/
#define WINDEX_C
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/tty.h>
#include <xview/termsw.h>
#include <xview/panel.h>
#include <xview/canvas.h>
#include <xview/cms.h>
#include <xview/font.h>
#include "motxer.h"


/*============================================================================*/
#define  SIZE_TXT_ITEM  20
#define  SIZE_IMPATH    20

#define  STDIN_FD       0
#define  STDOUT_FD      1

#define  COL_A          00
#define  COL_B          20
#define  COL_C          40
#define  COL_D          51
#define  COL_E          60

#define  HH_COL_A       00
#define  HH_COL_A1      10
#define  HH_COL_B       18
#define  HH_COL_C       26
#define  HH_COL_D       34
#define  HH_COL_E       42
#define  HH_COL_F       50
#define  HH_COL_G       58
#define  HH_COL_H       64
#define  HH_COL_I       50
#define  HH_COL_J       67
#define  HH_COL_K       67
#define  HH_COL_L       67

#define  IP_COL_A       00
#define  IP_COL_B       15
#define  IP_COL_C       25
#define  IP_COL_D       00
#define  IP_COL_E       00

#define  IP_COL_A1       00
#define  IP_COL_A2       10
#define  IP_COL_A3       20
#define  IP_COL_A4       30
#define  IP_COL_A5       40

#define  ROW_A          0
#define  ROW_B          1
#define  ROW_C          2
#define  ROW_D          3
#define  ROW_E          4
#define  ROW_F          5
#define  ROW_G          6
#define  ROW_H          7
#define  ROW_I          8
#define  ROW_J          9
#define  ROW_K          10
#define  ROW_L          11
#define  ROW_M          12
#define  ROW_N          13
#define  ROW_O          14
#define  ROW_P          15
#define  ROW_Q          16
#define  ROW_R          17
#define  ROW_S          18
#define  ROW_T          19
#define  ROW_U          20
#define  ROW_V          21
#define  ROW_W          22
#define  ROW_X          23
#define  ROW_Y          24
#define  ROW_Z          25

/*==================== Global variables ======================================*/
Frame mainframe;
Termsw term;
Xv_Font wx_font;

Frame statframe;
Panel statpanel;

Panel mainpanel;
Panel_item mp_impath, mp_utime, mp_xtime, mp_tleft, mp_cyctime;
Panel_item mp_loop_num, mp_nfsave, mp_expstate, mp_temp;
Panel_item mp_ncols, mp_nrows, mp_hbin, mp_vbin;
Panel_item mp_opch, mp_gain, mp_usec, mp_nch, mp_nccd, mp_namps, mp_sclks;
Panel_item mp_delay, mp_flag_show, mp_flag_cycle;
Panel_item mp_flag_shutter, mp_flag_flush, mp_flag_fsave;
Panel_item mp_flag_wipe, mp_flag_temp, mp_flag_verbose;

Panel_item bp_cmd1, bp_cmd2, bp_cmd3, bp_cmd4;
Panel_item bp_flush, bp_start, bp_abort, bp_show;

Frame infoframe;
Panel infopanel;
Panel_item ip_observer, ip_telescope, ip_object, ip_device;
Panel_item ip_label_A, ip_label_B, ip_label_C, ip_label_D;

Frame hardhatframe;
Panel hardhatpanel;
Panel_item hh_vclk[32], hh_vbias[16], hh_heat[8], hh_tec[2];
Panel_item hh_temp[8], hh_tset[8];
Panel_item hh_bp_apply, hh_bp_get;
Panel_item hh_bp_getheat, hh_bp_gettemp, hh_bp_setheat,hh_bp_settemp;
Panel_item hh_opselect, hh_label_A, hh_label_B, hh_label_C, hh_label_D;
Panel_item hh_flag_autotemp, hh_flag_autopid, hh_flag_verbose;

static int mainpanel_height  = 0;
static int wx_getnextline = 0;

int wx_done = 0;
char *wx_gotcl = NULL;
char wx_cmdbuf[80];
char dim[] = "none";
struct itimerval timer;
extern int fullscreendebug;

/*========== Function prototypes =============================================*/
static void wx_dummy(void);
static void showinfoframe(void);
static void showhhframe(void);
static void showplotframe(void);
static void wx_cmd_mac(Panel_item item, int value, Event* event);
static void wx_toggle_proc(Panel_item item, int value, Event* event);
static Panel_setting ip_notify_proc(Panel_item item, Event* event);
static Panel_setting mp_notify_proc(Panel_item item, Event* event);
static Panel_setting hh_notify_proc(Panel_item item, Event* event);
static Notify_value wx_readinput(Notify_client client, int in_fd);
static Notify_value timer_loop(void);
static Notify_value wx_destroy_func(Frame frame, Destroy_status status);
static void win_resize(Xv_Window window, Event* event);

/*============================================================================*/
void
win_init(int argc, char *argv[])
{
    char *fontname = "lucida-fixedwith";
    char c;
    int r;
    int tty_fd;
    Notify_client client_in;

    int xsize;
    void win_resize();
    extern char version[], impath[];
    extern IMDESC *im;

    xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
    fullscreendebug = 1;        // prevents xview lock-up

    mainframe = (Frame)xv_create(XV_NULL, FRAME,
        FRAME_ARGS,     argc, argv,
        FRAME_LABEL,    version,
        NULL);

    wx_font = (Xv_Font)xv_find(mainframe, FONT,
        FONT_FAMILY,    FONT_FAMILY_LUCIDA_FIXEDWIDTH,
//      FONT_FAMILY,    FONT_FAMILY_DEFAULT_FIXEDWIDTH,
        FONT_STYLE,     FONT_STYLE_NORMAL,
        FONT_SIZE,      12,
        NULL);
    if (!wx_font) {
        printf("%s: cannot use font: %s\n", argv[0], fontname);
        wx_font = (Xv_Font)xv_get(mainframe, XV_FONT);
    }

    argv++;
    term = (Termsw)xv_create(mainframe, TERMSW,
        TTY_ARGV,       argv,
        TTY_ARGV,       TTY_ARGV_DO_NOT_FORK,
        WIN_FONT,       wx_font,
        WIN_ROWS,       10,
        WIN_COLUMNS,    75,
        NULL);

    /* set up a panel for stats & control stuff*/
    mainpanel = xv_create(mainframe, PANEL,
        WIN_FONT,       wx_font,
        WIN_BELOW,      term,
        WIN_X,          0,
        NULL);

    /* control option buttons */
    xv_create(mainpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Info ",
        PANEL_NOTIFY_PROC,      showinfoframe,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_E),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_A),
        NULL);
    xv_create(mainpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Plot ",
        PANEL_NOTIFY_PROC,      showplotframe,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_E),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_B),
        NULL);
    xv_create(mainpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "HardHat",
        PANEL_NOTIFY_PROC,      showhhframe,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_E),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_C),
        NULL);

    /* control function buttons */
    bp_flush = xv_create(mainpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Flush",
        PANEL_NOTIFY_PROC,      clear_ccd,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_C),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_A),
        NULL);
    bp_start = xv_create(mainpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Start",
        PANEL_NOTIFY_PROC,      ccdexp_start,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_C),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_B),
        NULL);
    bp_abort = xv_create(mainpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Abort",
        PANEL_NOTIFY_PROC,      ccdexp_abort,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_C),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_C),
        NULL);

    /* control flag toggle buttons */
    mp_flag_show = xv_create(mainpanel, PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,   "AutoShow", NULL,
        PANEL_NOTIFY_PROC,      wx_toggle_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_B),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_A),
        NULL);
    mp_flag_cycle = xv_create(mainpanel, PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,   "AutoCycle", NULL,
        PANEL_NOTIFY_PROC,      wx_toggle_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_B),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_B),
        NULL);
    mp_flag_shutter = xv_create(mainpanel, PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,   "AutoShutter", NULL,
        PANEL_NOTIFY_PROC,      wx_toggle_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_B),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_C),
        NULL);
    mp_flag_flush = xv_create(mainpanel, PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,   "AutoFlush", NULL,
        PANEL_NOTIFY_PROC,      wx_toggle_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_B),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_D),
        NULL);
    mp_flag_wipe = xv_create(mainpanel, PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,   "AutoWipe", NULL,
        PANEL_NOTIFY_PROC,      wx_toggle_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_B),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_E),
        NULL);
    mp_flag_fsave = xv_create(mainpanel, PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,   "AutoSave", NULL,
        PANEL_NOTIFY_PROC,      wx_toggle_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_B),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_F),
        NULL);
    mp_flag_temp = xv_create(mainpanel, PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,   "AutoTemp", NULL,
        PANEL_NOTIFY_PROC,      wx_toggle_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_B),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_G),
        NULL);
    mp_flag_verbose = xv_create(mainpanel, PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,   "Verbose", NULL,
        PANEL_NOTIFY_PROC,      wx_toggle_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_B),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_H),
        NULL);

    /* command macro function buttons */
    bp_cmd1 = xv_create(mainpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "cmd1",
        PANEL_NOTIFY_PROC,      wx_cmd_mac,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_D),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_A),
        NULL);
    bp_cmd2 = xv_create(mainpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "cmd2",
        PANEL_NOTIFY_PROC,      wx_cmd_mac,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_D),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_B),
        NULL);
    bp_cmd3 = xv_create(mainpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "cmd3",
        PANEL_NOTIFY_PROC,      wx_cmd_mac,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_D),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_C),
        NULL);

    /* timing display items & image path */
    mp_utime = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "UT: ",
        PANEL_VALUE,            "",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_A),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_A),
        NULL);
    mp_xtime = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "xtime:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_A),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_B),
        NULL);
    mp_tleft = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "tleft:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_A),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_C),
        NULL);
    mp_cyctime = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "cycle:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_A),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_D),
        NULL);
    mp_loop_num = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "Loop: ",
        PANEL_VALUE,            "1",
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_A),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_E),
        NULL);
    mp_nfsave = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "File: ",
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_A),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_F),
        NULL);
    mp_expstate = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "State:",
        PANEL_VALUE,            "????",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_A),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_G),
        NULL);
    mp_temp = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "Temp: ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_A),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_H),
        NULL);
    mp_opch = xv_create(mainpanel, PANEL_CYCLE,
        PANEL_LABEL_STRING,     "CH    ",
#ifdef BASE
        PANEL_CHOICE_STRINGS,   "A","B","C","D","E","F","G","H", NULL,
#endif // BASE
#ifdef GCAM
        PANEL_CHOICE_STRINGS,   "A","B","Both","Four", NULL,
#endif // GCAM
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_C),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_D),
        NULL);
    mp_sclks = xv_create(mainpanel, PANEL_CYCLE,
        PANEL_LABEL_STRING,     "Sclks ",
        PANEL_CHOICE_STRINGS,   "L", "R", NULL,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_C),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_E),
        NULL);
    mp_gain = xv_create(mainpanel, PANEL_CHOICE,
        PANEL_LABEL_STRING,     "Gain  ",
        PANEL_CHOICE_STRINGS,   "L", "H", NULL,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_C),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_F),
        NULL);
    mp_usec = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "CDS :",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_C),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_G),
        NULL);
    mp_nrows = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "Nrows:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_E),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_D),
        NULL);
    mp_ncols = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "Ncols:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_E),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_E),
        NULL);
    mp_hbin = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "Hbin: ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_E),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_F),
        NULL);
    mp_vbin = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "Vbin: ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_E),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_G),
        NULL);
    mp_nccd = xv_create(mainpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "Nch:  ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      mp_notify_proc,
        PANEL_ITEM_X,           xv_col(mainpanel,COL_E),
        PANEL_ITEM_Y,           xv_row(mainpanel,ROW_H),
        NULL);

    window_fit(mainpanel);
    window_fit(mainframe);

    xsize = xv_get(mainframe, XV_WIDTH);
    xv_set(term, XV_WIDTH, xsize, NULL);
    mainpanel_height = xv_get(mainpanel, XV_HEIGHT);
    xv_set(mainframe, WIN_CONSUME_EVENTS,
        WIN_RESIZE,         NULL,
        WIN_EVENT_PROC,     win_resize,
        NULL);

    /* create the fitsinfo subframe and panel */
    infoframe = xv_create(mainframe, FRAME,
        NULL);
    infopanel = xv_create(infoframe, PANEL,
        WIN_FONT,       wx_font,
        WIN_ROW_GAP,    1,
        NULL);

    /* create the hardhat subframe and panel */
    hardhatframe = xv_create(mainframe, FRAME,
        NULL);
    hardhatpanel = xv_create(hardhatframe, PANEL,
        WIN_FONT,       wx_font,
        WIN_ROW_GAP,    1,
        NULL);

#ifdef BASE
    hh_label_A = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "Channel  ",
        PANEL_VALUE,            "  A  ",
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_DISPLAY_LENGTH, 5,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_A),
        NULL);
    hh_label_B = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE,            "  B  ",
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_DISPLAY_LENGTH, 5,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_A),
        NULL);
    hh_label_C = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE,            "  C  ",
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_DISPLAY_LENGTH, 5,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_C),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_A),
        NULL);
    hh_label_D = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE,            "  D  ",
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_DISPLAY_LENGTH, 5,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_D),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_A),
        NULL);

    /* set up a simple panel subwindow */
    hh_vclk[31] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_B),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[30] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_C),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[29] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_D),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[28] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_E),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[27] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_F),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[26] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_G),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[25] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK3_H:",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_B),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[24] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK3_L:",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_C),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[23] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK2_H:",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_D),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[22] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK2_L:",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_E),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[21] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK1_H:",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_F),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[20] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK1_L:",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_G),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[19] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_H),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[18] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_I),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[17] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "SCLK_H: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_H),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[16] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "SCLK_L: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_I),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[15] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_J),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[14] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_K),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[13] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "TG_H:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_J),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[12] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "TG_L:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_K),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[11] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_L),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[10] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_M),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[9] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "SW_H:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_L),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[8] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "SW_L:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_M),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[7] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_N),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[6] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_O),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[5] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "RG_H:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_N),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[4] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "RG_L:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_O),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[3] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_P),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[2] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_Q),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[1] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "IPC_H:  ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_P),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[0] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "IPC_L:  ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_Q),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);

    hh_vbias[15] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_R),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[14] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_S),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[13] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_T),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[12] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_U),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[11] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_V),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[10] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_W),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[9] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_X),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[8] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_B),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_Y),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);

    hh_vbias[7] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "OD:     ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_R),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[6] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "OFD:    ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_S),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[5] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "SPARE:  ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_T),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[4] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "RD:     ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_U),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[3] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "ABG:    ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_V),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[2] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "OG:     ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_W),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[1] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "ADJ:    ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_X),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[0] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "OFF:    ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_Y),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);

    hh_bp_get = xv_create(hardhatpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Get",
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_Z),
        PANEL_NOTIFY_PROC,      hh_notify_proc,
        NULL);
    hh_bp_apply = xv_create(hardhatpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Apply",
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A1),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_Z),
        PANEL_NOTIFY_PROC,      hh_notify_proc,
        NULL);
#endif // BASE

#ifdef BASE
    ip_label_A = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "      TEMP ",
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_DISPLAY_LENGTH, 3,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_A),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    ip_label_B = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "  TSET ",
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_DISPLAY_LENGTH, 3,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_B),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_A),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    ip_label_C = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "  HEAT ",
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_DISPLAY_LENGTH, 3,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_C),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_A),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_temp[7] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "H: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_I),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_temp[6] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "G: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_H),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_temp[5] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "F: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_G),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_temp[4] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "E: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_F),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_temp[3] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "D: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_E),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_temp[2] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "C: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_D),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_temp[1] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "B: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_C),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_temp[0] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "A: ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_B),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);

    hh_tset[7] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_B),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_I),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_tset[6] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_B),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_H),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_tset[5] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_B),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_G),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_tset[4] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_B),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_F),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_tset[3] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_B),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_E),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_tset[2] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_B),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_D),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_tset[1] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_B),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_C),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_tset[0] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_B),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_B),
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);

    hh_heat[7] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_C),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_I),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_heat[6] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_C),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_H),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_heat[5] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_C),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_G),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_heat[4] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_C),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_F),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_heat[3] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_C),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_E),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_heat[2] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_C),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_D),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_heat[1] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_C),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_C),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_heat[0] = xv_create(infopanel, PANEL_TEXT,
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_C),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_B),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);

    hh_flag_autopid = xv_create(infopanel, PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,   "AutoPID", NULL,
        PANEL_NOTIFY_PROC,      wx_toggle_proc,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A1),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_J),
        NULL);
    hh_bp_gettemp = xv_create(infopanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "GetTemp",
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A1),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_L),
        PANEL_NOTIFY_PROC,      ip_notify_proc,
        NULL);
    hh_bp_settemp = xv_create(infopanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "SetTemp",
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A2),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_L),
        PANEL_NOTIFY_PROC,      ip_notify_proc,
        NULL);
    hh_bp_getheat = xv_create(infopanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "GetHeat",
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A1),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_M),
        PANEL_NOTIFY_PROC,      ip_notify_proc,
        NULL);
    hh_bp_setheat = xv_create(infopanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "SetHeat",
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A2),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_M),
        PANEL_NOTIFY_PROC,      ip_notify_proc,
        NULL);
#endif // BASE

#ifdef GCAM
    /* set up a simple panel subwindow */
    hh_vclk[15] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK3_H:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_A),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[14] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK3_L:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_B),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[13] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK2_H:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_C),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[12] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK2_L:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_D),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[11] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK1_H:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_E),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[10] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "PCLK1_L:",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_F),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[9] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "TG_H:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_G),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[8] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "TG_L:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_H),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[7] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "DG_H:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_I),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[6] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "DG_L:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_J),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[5] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "SCLK_H: ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_K),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[4] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "SCLK_L: ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_L),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[3] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "RG_H:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_M),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[2] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "RG_L:   ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_N),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[1] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "IPC_H:  ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_O),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vclk[0] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "IPC_L:  ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_P),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);

    hh_vbias[7] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "ODL:    ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_Q),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[6] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "ODR:    ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_R),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[5] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "RD:     ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_S),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[4] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "SPARE:  ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_T),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[3] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "OG:     ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_U),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[2] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "TEC:    ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_V),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[1] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "OFF_L:  ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_W),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_vbias[0] = xv_create(hardhatpanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "OFF_R:  ",
        PANEL_VALUE_DISPLAY_LENGTH, 6,
        PANEL_NOTIFY_PROC,      wx_dummy,
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_X),
        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);

    hh_bp_get = xv_create(hardhatpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Get",
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_Y),
        PANEL_NOTIFY_PROC,      hh_notify_proc,
        NULL);
    hh_bp_apply = xv_create(hardhatpanel, PANEL_BUTTON,
        PANEL_LABEL_STRING,     "Apply",
        PANEL_ITEM_X,           xv_col(hardhatpanel,HH_COL_A1),
        PANEL_ITEM_Y,           xv_row(hardhatpanel,ROW_Y),
        PANEL_NOTIFY_PROC,      hh_notify_proc,
        NULL);
#endif // GCAM

#ifdef GCAM
    hh_temp[0] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "Temp (C): ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_B),
        PANEL_NOTIFY_PROC,      wx_dummy,
//        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
    hh_tec[0] = xv_create(infopanel, PANEL_TEXT,
        PANEL_LABEL_STRING,     "TEC (mA): ",
        PANEL_VALUE_DISPLAY_LENGTH, 8,
        PANEL_ITEM_X,           xv_col(infopanel,IP_COL_A),
        PANEL_ITEM_Y,           xv_row(infopanel,ROW_C),
        PANEL_NOTIFY_PROC,      wx_dummy,
//        PANEL_VALUE_UNDERLINED, FALSE,
        NULL);
#endif // GCAM

    window_fit(infopanel);
    window_fit(infoframe);

    window_fit(hardhatpanel);
    window_fit(hardhatframe);

    /* Note that dup() duplicates an existing descriptor */
    tty_fd = (int)xv_get(term, TTY_TTY_FD);
    dup2(tty_fd, STDOUT_FD);
    dup2(tty_fd, STDIN_FD);

    client_in = (Notify_client) &client_in;
    notify_set_input_func(client_in, wx_readinput, STDIN_FD);
    xv_set(mainframe, WIN_SHOW, TRUE, NULL);
}

void
win_start_timer(int interval)
{
    timer.it_interval.tv_usec = interval;
    timer.it_value.tv_usec = interval;
    notify_set_itimer_func(mainframe, timer_loop, ITIMER_REAL, &timer, NULL);
    xv_main_loop(mainframe);
}

static Notify_value
wx_destroy_func(Frame frame, Destroy_status status)
{
    extern int wx_done;

    if(status != DESTROY_CHECKING) {
        wx_done = 1;
        notify_stop();
    }
    return(notify_next_destroy_func(frame, status));
}

static Notify_value
timer_loop(void)
{
    check_timer();
}

/*========== Window service routines =========================================*/
static void
wx_dummy(void)
{
    static int flag = FALSE;
}

static void
showinfoframe(void)
{
    static int fitsflag = FALSE;

    if(fitsflag== TRUE)
        fitsflag = FALSE;
    else
        fitsflag = TRUE;

    xv_set(infoframe, WIN_SHOW, fitsflag, NULL);
}

static void
showhhframe(void)
{
    static int hhwinflag = FALSE;

    if(hhwinflag== TRUE)
        hhwinflag = FALSE;
    else
        hhwinflag = TRUE;

    xv_set(hardhatframe, WIN_SHOW, hhwinflag, NULL);
}

static void
showplotframe(void)
{
    static int isopen =  FALSE;

    if(isopen== TRUE) {
        pstextmode();
        psclose();
        isopen = FALSE;
    }
    else {
        psopen("x11", 'n', "");
        isopen = TRUE;
    }
}

static Panel_setting
mp_notify_proc(Panel_item item, Event* event)
{
    extern char impath[];
    extern SEQ_MODE *seq;
    extern int seqflag;
    extern double exptime, cyctime;
    extern int loop_num, nfsave;
    int r;

    if (item == mp_impath){
        strcpy(impath, (char*)panel_get(item, PANEL_VALUE));
    }
    else if (item == mp_xtime){
        seqflag = SET_XTIME;
        exptime = atof((char*)panel_get(item, PANEL_VALUE));
    }
    else if (item == mp_cyctime){
        seqflag = SET_CYCTIME;
        cyctime = atof((char*)panel_get(item, PANEL_VALUE));
    }
    else if (item == mp_loop_num){
        loop_num = atoi((char*)panel_get(item, PANEL_VALUE));
        seqflag = SET_LOOPNUM;
    }
    else if (item == mp_hbin){
        seq->hbin = atoi((char*)panel_get(item, PANEL_VALUE));
        seqflag = SET_HBIN;
    }
    else if (item == mp_vbin){
        seq->vbin = atoi((char*)panel_get(item, PANEL_VALUE));
        seqflag = SET_VBIN;
    }
    else if (item == mp_ncols){
        seq->ncol = atoi((char*)panel_get(item, PANEL_VALUE));
        seqflag = SET_NCOLS;
    }
    else if (item == mp_nrows){
        seq->nrow = atoi((char*)panel_get(item, PANEL_VALUE));
        seqflag = SET_NROWS;
    }
    else if (item == mp_nccd){
        seq->nccd = atoi((char*)panel_get(item, PANEL_VALUE));
        seqflag = SET_NCCD;
    }
    else if (item == mp_opch){
        r = (int)panel_get(item, PANEL_VALUE);
#ifdef BASE
        seq->opch = r;
#endif // BASE
#ifdef GCAM
        seq->opch = r+1;                        // !!
#endif // GCAM
        seqflag = SET_OPCH;
    }
    else if (item == mp_sclks){
        r = (int)panel_get(item, PANEL_VALUE);
#ifdef BASE
        seq->sclks = r+1;
#endif // BASE
        seqflag = SET_SCLKS;
    }
    else if (item == mp_gain){
        seq->gain = (int)panel_get(item, PANEL_VALUE);
        seqflag = SET_GAIN;
    }
    else if (item == mp_usec){
        seq->usec = atoi((char*)panel_get(item, PANEL_VALUE));
        seqflag = SET_USEC;
    }
    else if (item == mp_nfsave){
        nfsave = atoi((char*)panel_get(item, PANEL_VALUE));
        seqflag = SET_FSAVE;
    }
    return(PANEL_NONE);
}


static Panel_setting
hh_notify_proc(Panel_item item, Event* event)
{
    extern SEQ_MODE *seq;
    extern int seqflag;
    char tmp_buf[80];
    int j,k;

    if (item == hh_bp_get){
        seqflag = GET_VDAC;
    }
    else if (item == hh_bp_apply){
        seqflag = SET_VDAC;
#ifdef BASE
//        k = 2*(seq->opch/2);
//        sprintf(tmp_buf, "  %s  ", channel[k]);
//        panel_set_value(hh_label_A, tmp_buf);
//        sprintf(tmp_buf, "  %s  ", channel[k+1]);
//        panel_set_value(hh_label_B, tmp_buf);
//        ud_hhpanel();
#endif // BASE
#ifdef BASE
        for (j=0; j<32; j++){
            seq->vclk[j] = atof((char*)panel_get(hh_vclk[j], PANEL_VALUE));
        }
        for (j=0; j<16; j++){
            seq->vbias[j] = atof((char*)panel_get(hh_vbias[j], PANEL_VALUE));
        }
#endif // BASE
#ifdef GCAM
        for (j=0; j<16; j++){
            seq->vclk[j] = atof((char*)panel_get(hh_vclk[j], PANEL_VALUE));
        }
        for (j=0; j<8; j++){
            seq->vbias[j] = atof((char*)panel_get(hh_vbias[j], PANEL_VALUE));
        }
#endif // GCAM
        ud_hhpanel();
    }
    return(PANEL_NONE);
}

static Panel_setting
ip_notify_proc(Panel_item item, Event* event)
{
    extern SEQ_MODE *seq;
    extern int hhflag;
    char tmp_buf[80];
    int j,k;

#ifdef BASE
    if (item == hh_bp_gettemp){
        hhflag = GET_TEMP;
    }
    else if (item == hh_bp_settemp){
        for (j=0; j<8; j++){
            seq->tset[j] = atof((char*)panel_get(hh_tset[j], PANEL_VALUE));
        }
        hhflag = SET_TEMP;
    }
    else if (item == hh_bp_getheat){
        hhflag = GET_HEAT;
    }
    else if (item == hh_bp_setheat){
        hhflag = SET_HEAT;
        for (j=0; j<8; j++){
            seq->heat[j] = atof((char*)panel_get(hh_heat[j], PANEL_VALUE));
        }
    }
#endif // BASE
//        ud_infopanel();

}


static void
wx_cmd_mac(Panel_item item, int value, Event* event)
{
    int cmdnum;
    char *cmdstr;
    extern char *wx_gotcl, wx_cmdbuf[];
    extern char cmd1[], cmd2[], cmd3[], cmd4[];

    if(item == bp_cmd1)
        strcpy(wx_cmdbuf, cmd1);
    else if(item == bp_cmd2)
        strcpy(wx_cmdbuf, cmd2);
    else if(item == bp_cmd3)
        strcpy(wx_cmdbuf, cmd3);
//  else if(item == bp_cmd4)
//      strcpy(wx_cmdbuf, cmd4);
    else {
        printf("command not defined\n");
        return;
    }
    wx_gotcl = wx_cmdbuf;
    printf("%s\n",wx_cmdbuf);
}

static void
wx_toggle_proc(Panel_item item, int value, Event* event)
{
    extern SEQ_MODE *seq;
    extern int showflag, cycleflag, autosave, autowipe, autoshutter;
    extern int autotemp, autoflush, pidflag, verbose;
    extern int seqflag, hhflag, wipeflag;

    if (item == mp_flag_show){
        if(value == ASSERTED) {
            showflag = ASSERTED;
            printf("Auto_show on\n");
        }
        else {
            showflag = !ASSERTED;
            printf("Auto_show off\n");
        }
    }
    else if (item == mp_flag_cycle){
        if(value == CYCLE_OFF) {
            cycleflag = CYCLE_OFF;
            printf("Cycle off\n");
        }
        else if(value == CYCLE_ON) {
            cycleflag = CYCLE_ON;
            printf("Cycle on\n");
        }
    }
    else if (item == mp_flag_shutter){
        if(value == ASSERTED) {
            printf("Auto shutter enabled\n");
            autoshutter = ASSERTED;
        }
        else {
            printf("Auto shutter disabled\n");
            autoshutter = !ASSERTED;
        }
    }
    else if (item == mp_flag_fsave){
        if(value == ASSERTED) {
            autosave = ASSERTED;
            printf("Autosave on\n");
        }
        else {
            autosave = !ASSERTED;
            printf("Autosave off\n");
        }
    }
    else if (item == mp_flag_wipe){
        if(value == ASSERTED) {
            autowipe = ASSERTED;
            printf("Autowipe on\n");
        }
        else {
            autowipe = !ASSERTED;
            printf("Autowipe off\n");
        }
        wipeflag = SET_WIPE;
//        seqflag = SET_WIPE;
    }
    else if (item == mp_flag_flush){
        if(value == ASSERTED) {
            autoflush = ASSERTED;
            printf("Autoflush on\n");
        }
        else {
            autoflush = !ASSERTED;
            printf("Autoflush off\n");
        }
    }
    else if (item == mp_flag_temp){
        if(value == ASSERTED) {
            autotemp = ASSERTED;
            printf("Temp monitoring on\n");
        }
        else {
            autotemp = !ASSERTED;
            printf("Temp monitoring off\n");
        }
    }
    else if (item == mp_flag_verbose){
        if(value == ASSERTED) {
            verbose = ASSERTED;
            printf("Verbose flag on\n");
        }
        else {
            verbose = !ASSERTED;
            printf("Verbose flag off\n");
        }
    }
    else if (item == hh_flag_autopid){
        if(value == ASSERTED) {
            pidflag = ASSERTED;
            seq->pid = 0x1;
            printf("AutoPID on\n");
        }
        else {
            pidflag = !ASSERTED;
            seq->pid = 0x0;
            printf("AutoPID off\n");
        }
        seqflag = SET_PID;
    }
}


static Notify_value
wx_readinput(Notify_client client, int in_fd)
{
    extern int  wx_getnextline;
    extern char wx_cmdbuf[], *wx_gotcl;
    char *ptr, *gets();

    ptr = fgets(wx_cmdbuf, 78, stdin);   /* read one line per call */

    /* handle end of file */
    if (ptr==NULL) {            /* Note: could have been a read error */
        xv_set(mainframe, FRAME_NO_CONFIRM, TRUE, NULL);
        window_done(term);
    }

    if(wx_getnextline  == 1) {
        wx_getnextline = 2;
    }
    else {
        wx_gotcl = wx_cmdbuf;
    }
    return(NOTIFY_DONE);
}


static void
win_resize(Xv_Window window, Event* event)
{
    extern Termsw term;
    extern int  mainpanel_height;
    int width;
    int height;

    switch(event_id(event)) {
    case WIN_RESIZE:
        {
        width = xv_get(mainframe, XV_WIDTH);
        height = xv_get(mainframe, XV_HEIGHT);
        xv_set(term, XV_WIDTH, width,
            NULL);
        xv_set(term, XV_HEIGHT, (height - mainpanel_height),
            NULL);
        xv_set(mainpanel,  XV_HEIGHT, mainpanel_height,
            WIN_BELOW,  term,
            XV_WIDTH,   width,
            NULL);
        break;
        }
    default:
        break;
    }
}


/*==========  Update routines ================================================*/
void
ud_clock(void)
{
    extern Panel_item mp_utime;
    extern double systime;
    char tmp_buf[80];
    static time_t ut;

    ut = (time_t)systime;
    strftime(tmp_buf, 80, "%T", gmtime(&ut));
    panel_set_value(mp_utime, tmp_buf);
}

void
ud_xtime(void)
{
    char tmp_buf[80];
    extern Panel_item mp_xtime;
    extern double exptime;

    sprintf(tmp_buf, "%6.1f", exptime);
    panel_set_value(mp_xtime, tmp_buf);
}

void
ud_tleft(void)
{
    char tmp_buf[80];
    extern Panel_item mp_tleft;
    extern double tleft;

    if(tleft < 0.0)tleft = 0.0;
    sprintf(tmp_buf, "%6.1f", tleft);
    panel_set_value(mp_tleft, tmp_buf);
}

void
ud_cyctime(void)
{
    char tmp_buf[80];
    extern Panel_item mp_cyctime;
    extern double cyctime;

    sprintf(tmp_buf, "%6.1f", cyctime);
    panel_set_value(mp_cyctime, tmp_buf);
}

void
ud_nfsave(void)
{
    char tmp_buf[80];
    extern Panel_item mp_nfsave;
    extern int nfsave;

    sprintf(tmp_buf, "  %3.3d", nfsave);
    panel_set_value(mp_nfsave, tmp_buf);
}

void
ud_cycle(int arg)
{
    extern Panel_item mp_flag_cycle;

    panel_set_value(mp_flag_cycle, arg);
}

void
ud_autosave(int arg)
{
    extern Panel_item mp_flag_fsave;

    panel_set_value(mp_flag_fsave, arg);
}

void
ud_autoshutter(int arg)
{
    extern Panel_item mp_flag_shutter;

    panel_set_value(mp_flag_shutter, arg);
}

void
ud_autoflush(int arg)
{
    extern Panel_item mp_flag_flush;

    panel_set_value(mp_flag_flush, arg);
}

void
ud_autowipe(int arg)
{
    extern Panel_item mp_flag_wipe;

    panel_set_value(mp_flag_wipe, arg);
}

void
ud_autoshow(int arg)
{
    extern Panel_item mp_flag_show;

    panel_set_value(mp_flag_show, arg);
}

void
ud_autotemp(int arg)
{
    extern Panel_item mp_flag_temp;

    panel_set_value(mp_flag_temp, arg);
}

void
ud_autopid(int arg)
{
    extern Panel_item hh_flag_autopid;

#ifdef BASE
    panel_set_value(hh_flag_autopid, arg);
#endif // BASE
}

void
ud_gain(int arg)
{
    extern Panel_item mp_gain;

    panel_set_value(mp_gain, arg);
}

void
ud_sclks(int arg)
{
    extern Panel_item mp_sclks;
#ifdef BASE
    if (arg==0x1) panel_set_value(mp_sclks, 0);
    if (arg==0x2) panel_set_value(mp_sclks, 1);
#endif // BASE
}

void
ud_opch(int arg)
{
    extern Panel_item mp_opch;

#ifdef GCAM
    if (arg==0x1) panel_set_value(mp_opch, 0);
    if (arg==0x2) panel_set_value(mp_opch, 1);
#endif // GCAM

#ifdef BASE
    if (arg>=0 && arg<=7) panel_set_value(mp_opch, arg);
#endif // BASE

}

void
ud_loop_num(int arg)
{
    char tmp_buf[80];
    extern Panel_item mp_loop_num;

    sprintf(tmp_buf, "%5d", arg);
    panel_set_value(mp_loop_num, tmp_buf);
}

void
ud_ncols(int arg)
{
    char tmp_buf[80];
    extern Panel_item mp_ncols;

    sprintf(tmp_buf, "%5d", arg);
    panel_set_value(mp_ncols, tmp_buf);
}

void
ud_nrows(int arg)
{
    char tmp_buf[80];
    extern Panel_item mp_nrows;

    sprintf(tmp_buf, "%5d", arg);
    panel_set_value(mp_nrows, tmp_buf);
}

void
ud_nch(int arg)
{

}

void
ud_nccd(int arg)
{
    char tmp_buf[80];
    extern Panel_item mp_nccd;

    sprintf(tmp_buf, "%5d", arg);
    panel_set_value(mp_nccd, tmp_buf);
}

void
ud_namps(int arg)
{
    char tmp_buf[80];
    extern Panel_item mp_namps;

#ifdef GCAM
    sprintf(tmp_buf, "%5d", arg);
//    panel_set_value(mp_namps, tmp_buf);
#endif // GCAM
}

void
ud_hbin(int arg)
{
    char tmp_buf[80];
    extern Panel_item mp_hbin;

    sprintf(tmp_buf, "%5d", arg);
    panel_set_value(mp_hbin, tmp_buf);
}

void
ud_vbin(int arg)
{
    char tmp_buf[80];
    extern Panel_item mp_vbin;

    sprintf(tmp_buf, "%5d", arg);
    panel_set_value(mp_vbin, tmp_buf);
}

void
ud_temp(void)
{
    extern Panel_item hh_temp[];
    extern SEQ_MODE *seq;
    char tmp_buf[80];
    int j;

#ifdef GCAM
    sprintf(tmp_buf, "%6.1f", seq->temp[0]);
    if (seq->temp[0] > 100.0 || seq->temp[0] < -200.0){
        sprintf(tmp_buf, "%5s"," - - ");
    }
    panel_set_value(hh_temp[0], tmp_buf);
    panel_set_value(mp_temp, tmp_buf);
#endif // GCAM

#ifdef BASE
    for (j=0; j<8; j++){
        sprintf(tmp_buf, "%6.1f", seq->temp[j]);
        if (seq->temp[j] > 100.0 || seq->temp[j] < -200.0){
            sprintf(tmp_buf, "%5s"," - - ");
        }
        panel_set_value(hh_temp[j], tmp_buf);

        sprintf(tmp_buf, "%6.1f", seq->tset[j]);
        if (seq->tset[j] > 100.0 || seq->tset[j] < -200.0){
            sprintf(tmp_buf, "%5s"," - - ");
        }
        panel_set_value(hh_tset[j], tmp_buf);
    }
#endif // BASE
}

void
ud_heat(void)
{
    extern Panel_item hh_heat[], hh_tec[];
    extern SEQ_MODE *seq;
    char tmp_buf[10];
    int j;

#ifdef GCAM
    sprintf(tmp_buf, "%6.1f", seq->tec[0]);
    if (seq->tec[0] < 0.0 || seq->tec[0] > 5.0){
        sprintf(tmp_buf, "%5s"," - - ");
    }
    panel_set_value(hh_tec[0], tmp_buf);
#endif // GCAM

#ifdef BASE
    for (j=0; j<8; j++){
        sprintf(tmp_buf, "%6.1f", seq->heat[j]);
        panel_set_value(hh_heat[j], tmp_buf);
    }
#endif // BASE
}

void
ud_usec(int arg)
{
    char tmp_buf[80];
    extern Panel_item mp_usec;

    sprintf(tmp_buf, "%5d", arg);
    panel_set_value(mp_usec, tmp_buf);
}

void
ud_impath(void)
{
    extern Panel_item mp_impath;
    extern char impath[];

//    panel_set_value(mp_impath, impath);
}

void
ud_exp_state(void)
{
    extern Panel_item mp_expstate;
    extern int expflag;

    switch(expflag) {
    case IDLE :
        panel_set_value(mp_expstate, " Idle");
        break;
    case CCDFLUSH :
        panel_set_value(mp_expstate, "Flush");
        break;
    case EXPSTART :
        panel_set_value(mp_expstate, "Start");
        break;
    case EXPOSE:
        panel_set_value(mp_expstate, "  Exp");
        break;
    case EXPABORT:
        panel_set_value(mp_expstate, "Abort");
        break;
    case CCDREAD :
        panel_set_value(mp_expstate, " Read");
        break;
    case SHOWNEW :
        panel_set_value(mp_expstate, " Show");
        break;
    case FILESAVE :
        panel_set_value(mp_expstate, "Fsave");
        break;
    case DELAYSTART :
        break;
    case EXPDELAY :
        panel_set_value(mp_expstate, "Delay");
        break;
    }
}

void
ud_hhpanel(void)
{
    extern Panel_item  hh_vclk[32], hh_vbias[16];
    extern SEQ_MODE *seq;

    char tmp_buf[10];
    int j;
#ifdef BASE
    for (j=0; j<32; j++){
        sprintf(tmp_buf, "%6.2f", seq->vclk[j]);
        panel_set_value(hh_vclk[j], tmp_buf);
    }

    for (j=0; j<16; j++){
        sprintf(tmp_buf, "%6.2f", seq->vbias[j]);
        panel_set_value(hh_vbias[j], tmp_buf);
    }
#endif // BASE
#ifdef GCAM
    for (j=0; j<16; j++){
        sprintf(tmp_buf, "%6.1f", seq->vclk[j]);
        panel_set_value(hh_vclk[j], tmp_buf);
    }

    for (j=0; j<8; j++){
        sprintf(tmp_buf, "%6.1f", seq->vbias[j]);
        panel_set_value(hh_vbias[j], tmp_buf);
    }
#endif // GCAM
}

void
ud_infopanel(void)
{
    extern Panel_item  hh_heat[], hh_tec[];
    extern SEQ_MODE *seq;
    char tmp_buf[10];
    int j;

#ifdef GCAM
    sprintf(tmp_buf, "%6.1f", seq->temp[0]);
    if (seq->temp[0] < -200.0 || seq->temp[0] > 100.0){
        sprintf(tmp_buf, "%5s"," - - ");
    }
    panel_set_value(hh_temp[0], tmp_buf);
    panel_set_value(mp_temp, tmp_buf);

    sprintf(tmp_buf, "%6.1f", seq->tec[0]);
    if (seq->tec[0] < 0.0 || seq->tec[0] > 5.0){
        sprintf(tmp_buf, "%5s"," - - ");
    }
    panel_set_value(hh_tec[0], tmp_buf);
#endif // GCAM

#ifdef BASE
    for (j=0; j<8; j++){
        sprintf(tmp_buf, "%6.1f", seq->temp[j]);
        panel_set_value(hh_temp[j], tmp_buf);
    }
    for (j=0; j<8; j++){
        sprintf(tmp_buf, "%6.1f", seq->tset[j]);
        panel_set_value(hh_tset[j], tmp_buf);
    }
    for (j=0; j<8; j++){
        sprintf(tmp_buf, "%6.1f", seq->heat[j]);
        panel_set_value(hh_heat[j], tmp_buf);
    }
#endif // BASE

}

/* End of File */


